module Panoramix
  module Tasks

    class Action
      attr_reader :name
      attr_reader :silent
      attr_reader :order_class
      attr_reader :tasks

      def initialize(action_name, silent, order_class)
        @name = action_name
        @silent = silent
        @order_class = order_class
        @tasks = []
      end

      def addTask(name, instance_type)
        @tasks.push Hash[:name => name, :instance_type => instance_type]
      end

    end

    Actions = Array.new
    Actions.push(Action.new("delete", false,  [Plugin::CloudFormation]))
    Actions.push(Action.new("stack_name", false,  [Plugin::CloudFormation]))
    Actions.push(Action.new("ps", false,	[Plugin::DockerUp, Plugin::CloudFormation, Plugin::Environment]))
    Actions.push(Action.new("rm", false,  [Plugin::DockerUp]))
    Actions.push(Action.new("id", false,  [Plugin::DockerUp]))
    Actions.push(Action.new("vars", false,  [Plugin::Environment]))
    Actions.push(Action.new("logs", false,	[Plugin::DockerUp]))
    Actions.push(Action.new("clobber", false,	[Plugin::DockerUp, Plugin::DockerBuild,	Plugin::DockerImage]))
    Actions.push(Action.new("clean", true, [Plugin::Wget, Plugin::Git, Plugin::S3]))
    Actions.push(Action.new("stop", false, [Plugin::DockerUp]))
    Actions.push(Action.new("start", false, [Plugin::DockerUp]))
  end
end
