module Panoramix
  module Tasks
    module GlobalTasks
      module_function

      def define_tasks
        descriptions = I18n.t('global')
        Panoramix::Tasks::Actions.each do |action|

          block = Proc.new  do |t|
            action.order_class.each do |type| 
              action.tasks.each do |task|
                if task[:instance_type].to_s == type.to_s
                  Rake::Task[task[:name]].invoke
                end
              end
            end
          end

          Panoramix.define_task(action.name, [], descriptions[action.name.to_sym], block)
        end
      end

    end
  end
end