module Panoramix
	module Tasks

		module MpiInfo
			module_function

			# This function defines the main task mpi_info
			def define_tasks

				block = Proc.new do |t| 
					puts "Base MPI".bold
					Panoramix::MPI.print_mpi 
					puts "\nExecuted MPI".bold
					Panoramix::MPI.print_final_mpi
					puts "\nDiff".bold
					Panoramix::MPI.diff_sh
				end

				# Define the mpi_info task
				Panoramix.define_task("mpi:info", [], I18n.t('mpi.info'), block)

				# Task body
				block = Proc.new { |t| Panoramix::MPI.print_mpi }

				# Define the mpi_info task
				Panoramix.define_task("mpi:base", [], I18n.t('mpi.base'), block)

				# Task body
				block = Proc.new { |t| Panoramix::MPI.print_final_mpi }

				# Define the mpi_info task
				Panoramix.define_task("mpi:final", [], I18n.t('mpi.final'), block)

				# Task body
				block = Proc.new { |t| Panoramix::MPI.diff_sh }

				# Define the mpi_info task
				Panoramix.define_task("mpi:diff", [], I18n.t('mpi.diff'), block)
			end
		end

		module MpiGen
			module_function

			# This function defines the main task mpi_gen
			def define_task

				# Task body
				block = Proc.new { |t| Panoramix::MPI.generate }
				# Define the mpi_gen task
				Panoramix.define_task("mpi:gen", [], I18n.t('mpi.gen'), block)
			end
		end

	end
end
